var fActive=false;
var fChangedCallback=[];
var iSubscriptDemo;
var lastUpdate=0;
var lastValue=0;
var fStepperBound;
var oGrid=null;

function initializeConsole() {
    var method;
    var noop = function () {};
    var methods = [
        'info', 'log', 'time', 'timeEnd',
        'debug', 'trace', 'warn'
    ];
    var length = methods.length;
    var console = (window.console = window.console || {});

    while (length--) {
        method = methods[length];

        // Only stub undefined methods.
        if (!console[method]) {
            console[method] = noop;
        }
    }
}

function changeListener(sValue) {
    
    var oValue=JSON.parse(sValue);
    var fActiveTemp=false;
    if (oValue!=null)
        if (oValue.result!=null)
            if (oValue.result.value!=null) {
                if (oValue.result.value)
                	fActiveTemp=true;
            }
    fActive=fActiveTemp;
	for (var iIndex=0;iIndex<fChangedCallback.length;iIndex++)
		fChangedCallback[iIndex]();
}


function requestAndUpdateDatabase() {
    dss.raiseEvent('led-wizard.db',{actions:'syncOnline'});   
} 


function startListener() {
	dss.ajaxAssyncRequestWithoutAnswer('/json/property/getBoolean',{path:'/scripts/led-wizard/demo/state'},changeListener);

	iSubscriptDemo = Math.floor(Math.random() * 100000000000);
	dss.ajaxSyncRequest('/json/event/subscribe', {
	    subscriptionID : iSubscriptDemo,
	    name : 'led-wizard.answer'
	});
	refreshListener();
}

function refreshListener() {
	dss.ajaxAssyncRequestWithoutAnswer('/json/event/get', {
	    subscriptionID : iSubscriptDemo,
	    timeout : 60 * 1000
	}, function(answer) {	
        try {
            var result = Ext.JSON.decode(answer);
    		if (result.ok==false)
    			if (result.message=="Subscription id not found!") {
    				iSubscriptDemo = Math.floor(Math.random() * 100000000000);
    				dss.ajaxSyncRequest('/json/event/subscribe', {
    				    subscriptionID : iSubscriptDemo,
    				    name : 'led-wizard.answer'
    				});
    				refreshListener();
    				return;
    			}
    		if (result.result == null) {
    			dss.ajaxAssyncRequestWithoutAnswer('/json/property/getBoolean',{path:'/scripts/led-wizard/demo/state'},changeListener);
    		} else {
    			for (var iIndex=0;iIndex<result.result.events.length;iIndex++) {
    				var oItem=result.result.events[iIndex].properties;
    				switch (oItem.type) {
    					case'step':{
    						if (fStepperBound!=null)
    							fStepperBound(answer);
    					}
                        break;
    					case 'demo':{					
    						if (oItem.state!=null) {
    							fActive=(oItem.state=="true");
    						}
    						if (oItem.step!=null) {
    							lastValue=Math.floor(parseInt(oItem.step,10)/2.56);
    						}
    						for (var jIndex=0;jIndex<fChangedCallback.length;jIndex++)
    							fChangedCallback[jIndex]();
    					}
                        break;
    					case 'saveDB':{
    						oGrid.setStatus(_('Loading ...'));
    						refreshIlluminantDB();
    					}
                        break;
    				}
    				
    			}			
    		}	
		} catch (e) {console.log("exception " + e.message+ " in refreshListener(): " + answer);}
		refreshListener();
	});
}
     			


Ext.define('DSS.addon.Lizard', {

    extend: 'DSS.addon.Framework',

    config: {
        appName: _('LED Wizard'),
        appId: 'led-wizard',
        appVersion: '1.1.5',
        dSSVersion : '1.9.0',
        appIcon: 'default_icon.png'
    },

    getHelp: function() {
        return Ext.create('Ext.Component', {
            whiteSpace : 'normal',
            padding : '0 20 0 0', //top right bottom left
            loader: {
                url: 'locale/' + dss.staticDataModel.activeLanguage + '/help.html',
                autoLoad: true,
                disableCaching: false
            }
        });
    },
    illuminantTypeControl:null,
    myGrid:null,
    setTestButtons: function () {
    	if (this.myGrid==null)
    		return;
        if (fActive) {
        	this.myGrid.btnDelete.setDisabled(true);
        	this.myGrid.btnCustom[0].setDisabled(true);
        	this.myGrid.btnCustom[1].setDisabled(false);
        } else {
        	this.myGrid.btnDelete.setDisabled((this.myGrid.curSelectedEvent==null));
        	this.myGrid.btnCustom[0].setDisabled(false);
        	this.myGrid.btnCustom[1].setDisabled(true);
        }
    },
    getContent: function() {
        var me=this;
        illuminantTypeControl= Ext.create('DSS.addon.IlluminantType' ,{});
        illuminantTestControl= Ext.create('DSS.addon.IlluminantTest' ,{});
        illuminantTypeControl.parent = this;
        
        var oConfig={
                defaultSortCol:'name',
                grouperField: 'grouping',
                multiselect: true,
                storeConfig: {
                    storeId : 'lizardStore',
                    fields : [ {name:'id'}, 
                               {name:'dsid', sortType:'asUCText'}, 
                               {name:'dsuid', sortType:'asUCText'}, 
                               {name:'devicename', sortType:'asUCText'}, 
                               {name:'catalogeID', sortType:'asUCText'},
                               {name:'ts'},
                               {name:'aaa'},
                               {name:'present'},
                               {name: 'grouping',  sortType: 'asUCText'}]  
                },
                columns: [ {
                    header : _('Device name'),
                    dataIndex : 'devicename',
                    renderer: function (val, metadata, record, rowIdx, colIdx, store, view) {  
                        var oDevice = dss.staticDataModel.getDevice(record.get('dsuid'));
                        if (record.get('present') === '') {
                            //device is not known to dSS
                            metadata.css='grid-cell-completly-wrong';
                        }
                        if (record.get('present') === false) {
                            //device is currently not connected to dSS
                            metadata.css='grid-cell-temporary-wrong'; 
                        }
                        var sString = '<table><tr><td style="padding-right:5px;"><img src="' + dss.staticDataModel.getImageForDevice(oDevice) + '"></td>';
                        sString += '<td>' + oDevice.name + _(" in ");
                        sString += dss.staticDataModel.getNameForZone(oDevice.ZoneID) + '</td></tr></table>'; 
                        
                        return sString;
                    },
                    flex : 3
                }, {
                    header: _('dSUID'),
                    dataIndex: 'dsuid',
                    xtype: 'devicedsidcolumn', 
                    width: 70,
                    customColumnRenderer: function (val, metadata, record, rowIdx, colIdx, store, view) {   
                        if (record.get('present') === '') {
                             //device is not known to dSS
                             metadata.css='grid-cell-completly-wrong';
                         }
                         if (record.get('present') === false) {
                             //device is currently not connected to dSS
                             metadata.css='grid-cell-temporary-wrong'; 
                         }
                         return val.slice(val.length-10, val.length-2);
                    }
                },{
                    header: _('led type'),
                    dataIndex: 'catalogeID',
                    xtype: 'textcolumn', 
                    customColumnRenderer: function (val, metadata, record, rowIdx, colIdx, store, view) {
                        if (record.get('present') === '') {
                            //device is not known to dSS
                            metadata.css='grid-cell-completly-wrong';
                        }
                        if (record.get('present') === false) {
                            //device is currently not connected to dSS
                            metadata.css='grid-cell-temporary-wrong'; 
                        }
                        var oRecord=Ext.data.StoreManager.lookup('illuminateTypeStore').findRecord('_id',val,0,false,false,true);    
                        if (oRecord==null) {
                            return _('led type is not found in database');
                        } else {
               			    return oRecord.get('socket') + ' ' + oRecord.get('name') + ' ' + oRecord.get('watt') + 'W ' + oRecord.get('colortemp');
                        }
                    },
                    flex :3
                }, {                    
                    header: _('manufacturer'),
                    dataIndex: 'catalogeID',
                    xtype: 'textcolumn', 
                    customColumnRenderer: function (val, metadata, record, rowIdx, colIdx, store, view) {
                        if (record.get('present') === '') {
                            //device is not known to dSS
                            metadata.css='grid-cell-completly-wrong';
                        }
                        if (record.get('present') === false) {
                            //device is currently not connected to dSS
                            metadata.css='grid-cell-temporary-wrong'; 
                        }
                        var oRecord=Ext.data.StoreManager.lookup('illuminateTypeStore').findRecord('_id',val,0,false,false,true);    
                        if (oRecord==null) {
                            return _('-');
                        } else {
                            var manuID=oRecord.get('manufactureID');
                            var oVendorRecord=Ext.data.StoreManager.lookup('illuminateVendorStore').findRecord('_id',manuID,0,false,false,true);
                            if (oVendorRecord!=null) {
                                return oVendorRecord.get('vendor').substr(1);   
                            } else {
                                return _('-');
                            }
                        }
                    },
                    flex :3
                }, {
                    header: _('modified at'),
                    dataIndex: 'ts',
                    xtype: 'timestampcolumn', 
                    width: 160,
                    customColumnRenderer: function (val, metadata, record, rowIdx, colIdx, store, view) {
                        if (record.get('present') === '') {
                            //device is not known to dSS
                            metadata.css='grid-cell-completly-wrong';
                        }
                        if (record.get('present') === false) {
                            //device is currently not connected to dSS
                            metadata.css='grid-cell-temporary-wrong'; 
                        }
                    }
                }],     
                buttonText: {
                    newButton: _('New device'),
                    editButton: _('Edit device'),
                    deleteButton: _('Reset device')
                },
                customButtons:[{
                    text:_('Make a Demo'),
                    iconCls:'icon-demo-start-action',
                    handler:function(grid,entry){
                    	dss.raiseEvent('led-wizard.demo',{actions:'startDemoModus', dsuid:entry.get('dsuid')});
                       
                    }
                },
                {
                    text:_('Stop Demo'),
                    iconCls:'icon-demo-stop-action',
                    handler:function(grid,entry){
                    	dss.raiseEvent('led-wizard.demo',{actions:'stopDemoModus'});
                    }
                },
                {
                    text:_('Request DB Refresh'),
                    iconCls:'',
                    handler:function(grid,entry){
                        dss.raiseEvent('led-wizard.db',{actions:'syncOnline'});
                    }
                }              
                ],
                editorConfig:{
                    title : _('Edit Deviceconfig'),
                    hideSave: true,
                    cancelTitle: _('Close'),
                    staticControls : [ {
                        type: 'hidden',
                        label: 'id',
                        id: 'id'
                    }],
                    tabControls : [{
                        tabLabel : _('Deviceselection'),
                        tabDescription : _('Choose the device, on which the dimmingcurve should be optimized'),
                        content : [{
                               type : 'deviceSelection',
                               id : 'dsuid', 
                               multiselect : true,
                               filterFunc: function (device) {return ((((device.functionID & 0xf000) >> 12) ==1) && (([200,6344,6345,1234,2248,6364].indexOf(device.productID)!=-1)&&(device.outputMode!=0)));}, 
                               specialDeviceRenderer:   function(val, metadata, record, colIdx, store, view) {
                                   var sReturn='<table style="height:16px;"><tr>';
                                   sReturn+='<td><img src="' + record.get('icon') + '" style="margin-right: 5px;"></td>';
                                   sReturn+='<td width="100%">' + record.get('name') + '</td><td>';
                                   sReturn+=dss.staticDataModel.getProductNameForDevice(dss.staticDataModel.getDevice(record.get('dSUID')))+'</td>';
                                   if (dss.staticDataModel.getDevice(record.get('dSUID')).outputMode==22)
                                		sReturn+='<td style="padding-left:5px;">' + _('dimmed') + '</td>';
                                   else
                                	   sReturn+='<td style="padding-left:5px;">' + _('switched') + '</td>';
                                   return sReturn +'</tr></table>';      
                               },
                               flex : true
                          }]
                    }, {
                        tabLabel : _('illuminant'),
                        tabDescription : _('Choose the type of the illuminant'),
                        content : [{
                            type : 'custom',
                            id : 'catalogeID',
                            control: illuminantTypeControl,
                            flex : true
                        }]
                    }, {
                        tabLabel : _('Test'),
                        tabDescription : _('Send the dimmingcurve to the device and test the result'),
                        content : [{
                            type : 'custom',
                            id : 'aaa',
                            control: illuminantTestControl,
                            flex : true
                        }]
                    }]
                },
                listeners: {
                    'loadDataStore':function (grid){
                        me.loadParameter(grid);
                    },
                    'saveEntry':function (grid,values){   
                    	 me.loadParameter(grid);
                    },
                    'deleteEntry':function (grid,entry){
                        var sWarningPermanentDeleted = _('This device was deleted from the system. Schould it be removed from the list whithout reseting the dimming curve?');
                        var sWarningNotConnected = _('This device is currently not connected to the system. Schould it be removed from the list whithout reseting the dimming curve?');
                        var messageBox = Ext.create('Ext.window.MessageBox', {
                            buttonText: {
                                yes: _('Yes'),
                                no: _('No')
                            }
                        });
                        var bPresentState=[];
                        var deviceID=[];
                        var iIndex, jIndex;
                        if (entry.length) {
                            for (iIndex=0;iIndex<entry.length;iIndex++) {
                                if (entry[iIndex]!=null) {
                                    bPresentState.push(entry[iIndex].get('present'));
                                    deviceID.push(entry[iIndex].get('dsuid'));
                                }
                            }
                        } else {
                            bPresentState.push(entry.get('present'));
                            deviceID.push(entry.get('dsuid'));
                        }
                        var bAsk = false;
                        for (jIndex = 0; jIndex<deviceID.length; jIndex++) {
                            if ((bPresentState[jIndex] === '') || (bPresentState[jIndex] === false)) {
                                bAsk = true;
                            }
                        }
                        if (bAsk) {
                            messageBox.show({
                                title:_('Remove Entry?'),
                                msg: _('At least one device not connected to the system. They will be removed from the list whithout reseting the dimming curve?'),
                                buttons:Ext.MessageBox.OKCANCEL,
                                buttonText :
                                {
                                  ok : _('OK'),
                                  cancel : _('Cancel')
                                },
                                icon: Ext.Msg.QUESTION,
                                fn: function (buttonID) {
                                    if (buttonID=='ok') {                                  
                                        me.myGrid.editorWindow.editControls.aaa.winWait.start({actions:'programmCurve',dsuid:Ext.JSON.encode(deviceID), curve_id:-1},0, deviceID.length);                            
                                    }
                                }
                            });
                        } else {
                            me.myGrid.editorWindow.editControls.aaa.winWait.start({actions:'programmCurve', dsuid:Ext.JSON.encode(deviceID), curve_id:-1},0, deviceID.length);
                        }
                    },
                    'selectionChanged': function(grid, selections) {
                        if (selections.length==1) {
                            var entry = selections[0];
                            if ((entry.get('present') === '') || (entry.get('present') === false)) {
                                //disable edit button if device is currently not connected or deleted
                                grid.btnEdit.setDisabled(true);                            
                            } else {
                                grid.btnEdit.setDisabled(false);                        }
                            }
                        }
                    }
        };   
        fChangedCallback.push(function () {me.setTestButtons();});
        this.myGrid=Ext.create('DSS.gridPanel', oConfig);
        var oEditor=this.myGrid.editorWindow;
        oGrid=this.myGrid;
        this.myGrid.editorWindow.buttonCancel.setHandler(function (){
        	var oDev=oEditor.editControls.dsuid.getValue();
        	var oIllu=oEditor.editControls.catalogeID.getValue();
        	if (oDev!=null) 
        		if (oIllu!=null)
	        		if (!oEditor.editControls.aaa.fHasActionDone) {
	        			
	        		    var messageBox = Ext.create('Ext.window.MessageBox', {
	        		        buttonText: {
	        		            yes: _('Yes'),
	        		            no: _('No')
	        		        }
	        		    });
	        		  	        			
	        		    messageBox.show({
			        	     title:_('Transmit curve?'),
			        	     msg: _('A device and a valid curve has been selected but not yet been transmitted. Should it be done now ?'),
			        	     buttons:Ext.MessageBox.YESNO,			        	    
			        	     icon: Ext.Msg.QUESTION,
			        	     fn: function (buttonID) {
			        	    	 if (buttonID=='yes') {			        	    		 
			        	    		 oEditor.editControls.aaa.winWait.start({actions:'programmCurve', dsuid:Ext.JSON.encode(oDev), curve_id:oEditor.editControls.catalogeID.getValue()});			        	    		 
			        	    	 }
			        	     }
			        	});
	        		}
        	oEditor.fireEvent('cancel');
        	oEditor.hide();
        });
        Ext.data.StoreManager.on('clear',function () {
                refreshIlluminantDB();
                me.myGrid.editorWindow.editControls.catalogeID.initStores();
                me.myGrid.editorWindow.editControls.catalogeID.updateGridStores();
                me.loadParameter(me.myGrid);
            });
        
        return this.myGrid;
    },   
    loadParameter : function(grid) {    	
    	grid.setStatus(_('Loading ...'));
    	this.myGrid=grid;
    	oEdit=grid.editorWindow;
    	this.myGrid.btnCustom[0].setVisible(false);
    	this.myGrid.btnCustom[1].setVisible(false);
    	this.myGrid.btnCustom[2].setVisible(false);
    	if (oEdit!=null)    
    		if (oEdit.displayBottomText!=null)    			
    			oEdit.displayBottomText.setValue(_('illuminant database updated on: ')+Ext.Date.format(lastUpdate, "d.m.Y H:i"));
        var sString = dss.ajaxSyncRequest('/json/property/query', {
            'query' : '/scripts/led-wizard/devices/*(*)'
        });
        try {
            var result = Ext.JSON.decode(sString);
            var oResultObject=dss.parsePropertyQueryAnswer(result,[{name:'dsid',type:'simple'},
                                                                   {name:'dsuid',type:'simple'},
                                                                   {name:'catalogeID',type:'simple'},
                                                                   {name: 'ts',type:'simple'}]);  
            if (oResultObject!=null) {
            	for (var iIndex=0;iIndex<oResultObject.length;iIndex++){
            	    var oDevice = dss.staticDataModel.getDevice(oResultObject[iIndex].dsuid);
            		oResultObject[iIndex].aaa="aaa";
            		oResultObject[iIndex].devicename= oDevice.name;
            		oResultObject[iIndex].present = oDevice.present;
            		var Room = dss.staticDataModel.getNameForZone(oDevice.ZoneID);
            		oResultObject[iIndex].grouping = unescape(Room);
            	}
                grid.loadParameter(oResultObject);
            }
            grid.setStatus(_('Ready'));
        } catch (e) {
            grid.setStatus(_('Error'));
            console.log("exception " + e.message+ " in loadParameter(): " + sString);
        }
    }
});

Ext.onReady(function() {
    initializeConsole();
    dss.buildUpLang(['locale/{languageSuffix}/led-wizard.po']);
    
    refreshIlluminantDB();
    requestAndUpdateDatabase();
    var ledwizard = Ext.create('DSS.addon.Lizard');
    ledwizard.initPage();
    startListener();
});

function refreshIlluminantDB (){
	 if (Ext.data.StoreManager.lookup('illuminateTypeStore') == null) {
	    Ext.create('Ext.data.Store', {
	        storeId : 'illuminateTypeStore',
	        fields : [ {name:'name', sortType: 'asUCText'},
	                   '_id',
	                   'ability',
	                   'abilityDetail',
	                   'colortemp',
	                   'curveValues',
	                   'dimmMinimum',
	                   'ean',
	                   'illuminateCount',
	                   'lumen',
	                   'manufactureID',
	                   'mount',
	                   'winkel',
	                   {name:'socket', sortType: 'asUCText'},
	                   {name:'watt',sortType:'asCommaFloat'}],
	        proxy : {
	            type : 'memory',
	            reader : {
	                type : 'json',
	                root : 'items'
	            }
	        }
	    });
	 }
	 if (Ext.data.StoreManager.lookup('illuminateTypeControlStore') == null) {
	    Ext.create('Ext.data.Store', {
	        storeId : 'illuminateTypeControlStore',
	        fields : [ {name:'name', sortType: 'asUCText'},
	                   '_id',
	                   'ability',
	                   'abilityDetail',
	                   'colortemp',
	                   'curveValues',
	                   'dimmMinimum',
	                   'ean',
	                   'illuminateCount',
	                   'lumen',
	                   'manufactureID',
	                   'mount',
	                   'winkel',
	                   {name:'socket', sortType: 'asUCText'},
	                   {name:'watt',sortType:'asCommaFloat'}],
	        proxy : {
	            type : 'memory',
	            reader : {
	                type : 'json',
	                root : 'items'
	            }
	        }
	    });
	 }
     if (Ext.data.StoreManager.lookup('illuminateVendorStore') == null) {	 
	    Ext.create('Ext.data.Store', {
	        storeId : 'illuminateVendorStore',
	        fields : [ '_id', {name:'vendor', sortType: 'asUCText'}, 'passive' ],
	        proxy : {
	            type : 'memory',
	            reader : {
	                type : 'json',
	                root : 'items'
	                }
	            }
	        });
	 }
	 Ext.data.StoreManager.lookup('illuminateVendorStore').removeAll();
	 Ext.data.StoreManager.lookup('illuminateTypeStore').removeAll();
	 Ext.data.StoreManager.lookup('illuminateTypeControlStore').removeAll();
	var sString = dss.ajaxSyncRequest('/json/property/getString', {
	    'path' : '/scripts/led-wizard/dbcache'
	});
	var iIndex;
	var jIndex;
	var kIndex;
	try {
    	var result = Ext.JSON.decode(sString);
    	if (result.ok) {
    	    var data=[];
    	    var vendorArray=[];
    	    var decoded=dss.unescapeProperty(result.result.value);
    	    var objCache=Ext.JSON.decode(decoded);
    	    for (iIndex=0;iIndex<objCache.statics.manufacture.length;iIndex++) {
    	    	var fAdd=false;
    	    	for (jIndex=0;jIndex<objCache.illuminant.length;jIndex++)
    	    		if (objCache.statics.manufacture[iIndex].id==objCache.illuminant[jIndex].manu_id)
    	    			fAdd=true;
    	    	var priority=2;
    	    	if (objCache.statics.manufacture[iIndex].id==-1)
    	    		priority=1;
    	    	if (fAdd)
    	    		Ext.data.StoreManager.lookup('illuminateVendorStore').add({_id:objCache.statics.manufacture[iIndex].id,vendor:""+priority+objCache.statics.manufacture[iIndex].name});
    	    }
    	    if (objCache.statics.abilityDetail.length>0) {
    	    	var choosenLanguage=dss.staticDataModel.activeLanguage;
    		    for (iIndex=0;iIndex<objCache.statics.abilityDetail.length;iIndex++) {
    		    	var sAbiString=objCache.statics.abilityDetail[iIndex].name;
    		    	if (sAbiString.indexOf('{')==0) { 
    			    	var oAbiObject=Ext.JSON.decode(sAbiString);
    			    	if (oAbiObject[choosenLanguage]!=null)
    			    		Gettext._locale_data['dss-addon-framework'].msgs[oAbiObject['en_US']]=[null,oAbiObject[choosenLanguage]];
    			    	objCache.statics.abilityDetail[iIndex].name=oAbiObject['en_US'];
    			    }
    		    	
    		    }
        	}
    	    Ext.data.StoreManager.lookup('illuminateVendorStore').add({_id:0,vendor:'0'+_('All vendors')});
    	    Ext.data.StoreManager.lookup('illuminateVendorStore').sort('vendor','ASC');   
    	    
    	    for (iIndex=0;iIndex<objCache.illuminant.length;iIndex++) {
    	    	for (jIndex=0;jIndex<objCache.illuminant[iIndex].curves.length;jIndex++) {
    	        	var oItem={
    	        			_id:objCache.illuminant[iIndex].curves[jIndex].id,
    	        			lumen:objCache.illuminant[iIndex].lumen,
    	        			ean:objCache.illuminant[iIndex].ean,
    	        			colortemp:objCache.illuminant[iIndex].colortemp,
    	        			manufactureID:objCache.illuminant[iIndex].manu_id,
    	        			watt:objCache.illuminant[iIndex].watt,
    	        			name:objCache.illuminant[iIndex].name,
    	        			winkel:objCache.illuminant[iIndex].winkel,
    	        			dimmMinimum:objCache.illuminant[iIndex].curves[jIndex].dimmMin,
    	        			illuminateCount:objCache.illuminant[iIndex].curves[jIndex].illcount,
    	        			ability:objCache.illuminant[iIndex].curves[jIndex].dsabi
    	        			};
    	        	
    	        	for (kIndex=0;kIndex<objCache.statics.mountingForm.length;kIndex++)
    	        		if (objCache.statics.mountingForm[kIndex].id==objCache.illuminant[iIndex].mount_id)
    	        			oItem.mount=objCache.statics.mountingForm[kIndex].name;
    	        	for (kIndex=0;kIndex<objCache.statics.socket.length;kIndex++)
    	        		if (objCache.statics.socket[kIndex].id==objCache.illuminant[iIndex].socket_id)
    	        			oItem.socket=objCache.statics.socket[kIndex].name;
    	        	for (kIndex=0;kIndex<objCache.statics.abilityDetail.length;kIndex++)
    	        		if (objCache.statics.abilityDetail[kIndex].id==objCache.illuminant[iIndex].curves[jIndex].abidetail)
    	        			oItem.abilityDetail=objCache.statics.abilityDetail[kIndex].name;
    
    	        	
    	        	oItem.curveValues=[];
    	        	for (kIndex=0;kIndex<objCache.illuminant[iIndex].curves[jIndex].values.length;kIndex++) {
    	        		oItem.curveValues.push({_id:objCache.illuminant[iIndex].curves[jIndex].values[kIndex].pos,value:objCache.illuminant[iIndex].curves[jIndex].values[kIndex].val});
    	        	}
    	        	oItem.curveValues.sort(function(a,b){return a._id-b._id;});
    	        	var fCurve=false;
    	        	var dimmMax=0;
    	        	var fMin=false;
    	        	for (kIndex=0;kIndex<oItem.curveValues.length;kIndex++) {
    	        		if (oItem.curveValues[kIndex]!=null) {
    	        			if (!fMin)
    			        		if (oItem.curveValues[kIndex]._id<=oItem.dimmMinimum)
    			        			if (oItem.dimmMinimum<oItem.curveValues[kIndex+1]._id) {
    			        				var oTempMinDim=oItem.curveValues[kIndex].value;	        				
    			        				oItem.dimmMinimum=Math.round(oTempMinDim/100);	        				
    			        				fMin=true;
    			        				fCurve=true;
    			        			}
    	        			if (oItem.curveValues[kIndex].value==9999)
    	        				fCurve=false;
    		        		
    		        		if (fCurve)
    		        			oItem.curveValues[kIndex].window=9999;
    		        		else
    		        			oItem.curveValues[kIndex].window=0;
    	        		}
    	        	}
    	        	if (oItem.illuminateCount==1) {
    	        		Ext.data.StoreManager.lookup('illuminateTypeStore').add(oItem);
    	        		//we do not show the dimming curve "Standard-Werkseinstellung" in the selection list
    	        		//because this curve is used for resetting and will remove device from list (#4501)
    	        		if (oItem._id !== -1) {
    	        		    Ext.data.StoreManager.lookup('illuminateTypeControlStore').add(oItem);
    	        		}
    	        	}
    	        }
    	    }
    	    Ext.data.StoreManager.lookup('illuminateTypeControlStore').sort('socket','ASC');
    		var sRefreshString = dss.ajaxSyncRequest('/json/property/getString', {
    		    'path' : '/scripts/led-wizard/dbrefresh'
    		});
    		var refreshResult = Ext.JSON.decode(sRefreshString);
    		if (refreshResult.ok) {
    			lastUpdate=new Date();
    			lastUpdate.setTime(parseInt(refreshResult.result.value,10));
    	    	if (oEdit!=null)    
    	    		if (oEdit.displayBottomText!=null)    			
    	    			oEdit.displayBottomText.setValue(_('illuminant database updated on: ')+Ext.Date.format(lastUpdate, "d.m.Y H:i"));
    		}
    		
    	}
    	if (oGrid!=null) {
    		oGrid.setStatus(_('Ready'));
    	}
	} catch (e) {
	    if (oGrid!=null) {
	        oGrid.setStatus(_('Error'));
	    }
        console.log("exception " + e.message+ " in refreshIlluminantDB()");
	}
}

Ext.apply(Ext.data.SortTypes, {
    asCommaFloat: function(oValue) {
        var sString=""+oValue;
        sString=sString.replace(',','.');
        return parseFloat(sString,10);
        }        
    }
    );


var oEdit=null;